using namespace std;
#include <vector>
#include <QApplication>
#include <QSystemTrayIcon>
#include <QMenu>
#include <QFileDialog>
#include <QtDBus>
#include <phononnamespace.h>
#include <audiooutput.h>
#include <mediaobject.h>
#include <backendcapabilities.h>
#include <path.h>
#include <string.h>
class Playlist
{
	vector<QString> playlist;
	int active;
	public:
		Playlist();
		void addFile(QString filename);
		int setActive(int id);
		QString getLastFileDir();
		QString getActiveFileName();
		Phonon::MediaSource *getNext();
};
class Tray:public QSystemTrayIcon
{
Q_OBJECT	
	Phonon::MediaObject *media;
	Phonon::MediaSource *source;
	QMenu *menu;
	QIcon *playIcon;
	QIcon *pauseIcon;
	QIcon *stopIcon;	
	QAction *openAction;
	QAction *playAction;
	QAction *stopAction;
	QAction *quitAction;
	QAction *nextAction;
	QString fileName;
	Playlist playlist;
	void startPlaying();
	public slots:
		void FileOpen();
		void Stop();
		void Play();
		void Quit();
		void Next();
		void Clicked(QSystemTrayIcon::ActivationReason reason);
		void newInstance(QString arg);
	public:
		Tray(QIcon *icon,QString filename=0);
		~Tray();
		
};
class TrayAdaptor:public QDBusAbstractAdaptor
{
	Q_OBJECT
	Q_CLASSINFO("D-Bus Interface", "cz.nodomain.trayplay.TrayPlay")
	
	Tray *tray;
	public:
		TrayAdaptor(Tray *t);
	public slots:
		QString newInstance(QString arg);
};
